package com.feinno.teatalkavsdk.service;

import com.feinno.teatalkavsdk.service.MainListener;
import com.feinno.teatalk.model.UserAccount;
import com.feinno.teatalk.model.chat.RCSSession;
import com.feinno.teatalk.model.chat.SessionTheme;
import com.feinno.teatalk.model.ActiveRegion;
import com.feinno.teatalk.model.RCSGroup;
import com.feinno.teatalk.model.RCSTag;
import com.feinno.teatalk.model.Organize;
import com.feinno.teatalk.model.OrganizeNotify;
import com.feinno.teatalk.model.FavoriteMsgInfo;
import android.content.ContentValues;
import com.feinno.teatalkavsdk.NotificationBuilder;
import com.feinno.teatalkavsdk.SocialNotificationBuilder;
import com.feinno.teatalk.model.sync.TContact;
import com.feinno.teatalk.model.social.SocialTopic;
import com.feinno.teatalk.model.social.SocialContactNotify;
import com.feinno.teatalk.model.social.SocialTopicInfo;
import com.feinno.teatalk.model.social.SocialComment;
import com.feinno.teatalk.model.social.SocialPraise;
import com.feinno.teatalk.model.social.SocialContact;
import com.allstar.cinclient.entity.PublicEntity;
import com.feinno.enterprise.addin.addressbook.adapter_cells.view_pair;
import com.feinno.enterprise.addin.addressbook.adapter_cells.AlphaSection;
import com.feinno.enterprise.addin.addressbook.adapter_cells.DeptInfor;
import com.feinno.enterprise.addin.addressbook.adapter_cells.EnterpriseInfo;
import com.feinno.simpl.core.tasks.TaskResult;
import com.feinno.teatalk.model.EmoticonPackageBean;
import com.feinno.teatalk.model.chat.EmoticonBean;
import com.feinno.teatalk.model.SearchResultInfo;

interface CoreListener{

	void registerListener(MainListener listener);

	void mainToCore(byte method,int event,inout byte[] msg);
	
	UserAccount readActiveUser ();
	void PutSettingDAO(in Uri uri, in String key, in String value);	/* settingdao */
	String GetSetting(in Uri uri, in String key);					/* settingdao */
	void updateNotEnabled();
	void updateEnabled(String regionAbbr);
	void insertUserAccountDAO(in UserAccount user);
	void initStatusMyEmotionPackageDAO();
	void resetStatusEmoticonDAO();
	Map getEmoticonByPackageId(in long packageId);
	List<EmoticonBean> getEmoticons(in Uri uri);
	EmoticonBean getEmoticon(in String fileId);
	EmoticonBean getCollectEmoticon(in String fileId);
	void insertEmoticon(in EmoticonBean bean, in Uri uri);
	void bulkInsertEmoticon(in List<EmoticonBean> list);
	int updateEmoticon(in EmoticonBean bean, in Uri uri);
	void deleteEmoticons(in List<EmoticonBean> emoticonList, in Uri uri);
	void deleteFromCollect(in String fileId);
	List<EmoticonPackageBean> getEmoticonPackages(in Uri uri);
	EmoticonPackageBean getEmoticonPackage(in long packageId, in Uri uri);
	String getEmoticonPackageTabIconPath(in long packageId);
	void deleteAllEmoticonPackages(in Uri uri);
	void deleteEmoticonPackage(in long packageId, in Uri uri);
	boolean insertEmoticonPackage(in EmoticonPackageBean emoticonPackage, in Uri uri);
	void updateEmoticonPackage(in EmoticonPackageBean emoticonPackage, in Uri uri);
	void updateStatusUserAccountDAO();
	
	RCSSession[] getSessionsSessionDAO (in String where, in String[] args); 
	void insertSessionDAO (in RCSSession session);
	void deleteSessionDAO(String sessionId, String from);
	RCSSession getSession(in String where, in String[] args, in boolean needCheck);
	void updateEnabledByList (in ActiveRegion[] activeRegions);
	void showSessionSessionDAO(in String sessionId, in String from);
	
	void insertMessageDAO (in String session, in ContentValues message);
	ContentValues getLastMessage(in String sessionId);
	ContentValues findMessageMessageDAO(in String sessionId, in String messageId);
	ContentValues[] getSessionMessage(String sessionId, String messageID, int count, long lower);
	long getMaxLocalSequenceMessageDAO(String sessionId);
	void updateMessageReadStatusMessageDAO(String sessionId);
	void updateMessageArrivedStatus(String sessionId, in long dateTime);
	void readMessageDAO(String sessionId);
	int getUnreadMessageCountMessageDAO(String sessionId);
	ContentValues getDraftMessage(String sessionId);
	int getMessageCount(String sessionId);
	void resetStatusMessageDAO(String sessionId);
	int updateMessageDAO(in ContentValues message, in String sessionId);
	List<ContentValues> getMultipleMessage(long localSequence);
	
	void updateUnreadCountSessionInfoDAO(in long peerId, in int unreadCount);
	long getMaxSequence(long peerId);
	int getMessageStatusSessionInfoDAO(long peerId);
	int getUnreadCountSessionInfoDAO(long peerId);
	void updateStatusSessionInfoDAO(long peerId, int status);
	
	void deleteTableSessionManager(String sessionId);
	void updateIDNumberPair (in long[] ids, in String[] nums);
	void setClientProcessName (String process_name);
	
	void setNotificationBuilder (in NotificationBuilder b);
	void setSocialNotificationBuilder(in SocialNotificationBuilder b);
	byte getConnectState();
	
	List<TContact> getAllDataRCSContactDataDAO();
	List<TContact> getDataByUserId(long userId);
	List<TContact> getDataByMobileNum(String mobile);
	List<TContact> getDataByContactId(long contactId);
	List<TContact> getDataByDummyUserIdMobile(in List userId, in List<String> mobile);
	List<TContact> getDataByUserIds(in List userI);
	
	List getContactIdsPhoneBookMappingDAO(String md5);
	
	List<String> getAllContactFavorContactDAO();
	
	List<RCSGroup> getGroupsGroupDAO(in String where, in String[] args);
	RCSGroup getGroupGroupDAO(in String where, in String[] args);
	
	List<RCSTag> getTagsTagDAO(in String where, in String[] args);
    RCSTag getTagTagDAO(in String where, in String[] args);
	
	List<Organize> getOrganizesOrganizeDAO(in String where, in String[] args);
	Organize getOrganizeOrganizeDAO(in String where, in String[] args);
	
	OrganizeNotify getOrganizeNotifyOrganizeNotifyDAO(in String where, in String[] args);
	List<OrganizeNotify> getOrganizeNotifysOrganizeNotifyDAO(in String where, in String[] args);
	void deleteOrganizeNotifyOrganizeNotifyDAO(in String where,in String[] args);
	void upDataOrganizeNotifyIsReadDAO(long notifyId);
	
	long[] getGroupMemberUserIdGroupMappingDAO(long groupId);
	int getGroupMemberCountGroupMappingDAO(long groupId);
	
	long[] getTagMemeberUserIdTagMappingDao(long tagId);
	int getTagMemberCountTagMappingDao(long tagId);
	
	long[] getTagByUserId(long userId);
	
	
	long[] getOrganizeMemberUserIdOrganizeMappingDAO(long groupId);
	int getOrganizeMemberCountOrganizeMappingDAO(long groupId);
	List<SearchResultInfo> searchOrganize(String content);
	List<SearchResultInfo> searchGroup(String content);
	
	void initUserDB (long id);
	
	long[] getAllIdsSocialContactDAO();
	
	List<SocialTopic> getTopicsSocialTopicDAO(long topicId);
	List<ContentValues> getDraftTopicsSocialTopicInfoDAO(long timestamp);
	
	int getUnreadNotifyCount();	// SocialContactNotifyDAO
	void readAll();				// SocialContactNotifyDAO
	List<SocialContactNotify> getAllSocialContactNotify();	// SocialContactNotifyDAO
	int updateSCNDAO(in SocialContactNotify notify);		// SocialContactNotifyDAO
	void deleteSCNDAO(String messageID);					// SocialContactNotifyDAO
			
	void insertSTIDAO(in ContentValues topicinfo);								// SocialTopicInfoDAO
	void deleteSTIDAO(String messageId);										// SocialTopicInfoDAO
	
	List<SocialComment> getComments(String where, in String[] args, String order); // SocialCommentDAO
	int getUnreadCommentCount();													// SocialCommentDAO
	void readAllSCDAO();															// SocialCommentDAO	
	List<ContentValues> getUnreadCommentsPacked(boolean unReaded);					// SocialCommentDAO		
	void deleteNotify(long commentId);												// SocialCommentDAO
	List<SocialPraise> getSocialPraiseMap(long topicId);
	
	List<ContentValues> getUnreadCommentsPackedNotify(boolean unReaded);					// SocialCommentDAO	
	
	void findBaseComment(long topicId, long commentId, out List<SocialComment> comm, out List<SocialPraise> praise);	//SocialCommentDAO
	SocialContact getSocialContactDAO(long userId);
	
	List<PublicEntity> getFocusPublicList();
	List<PublicEntity> getSearchPublicList();
	PublicEntity getCurrentPublic();
	boolean updatePublic(in PublicEntity entity);

	List<FavoriteMsgInfo> getListNoParseFavoriteMsgDAO (long selfUserId);
	List<FavoriteMsgInfo> getListNoParseFavoriteMsgDAO2 (long selfUserId, int start, int pageSize);
	List<FavoriteMsgInfo> getListNoParseServerFavoriteMsgDAO2 (long selfUserId, int start, int pageSize);
	boolean getFavoriteSync();

	ContentValues getRobotOrPublicSessionMap(int type);
	List<ContentValues> getSessionImageMessageContents (String sessionId, String orderBy);
	FavoriteMsgInfo getWithBlob(String messageId, long selfUserId);
	void insertFavoriteMsgDAO(in ContentValues values);
	
	 SessionTheme getSessionThemeByUserId(long userId);
	 void insertSessionThemeDAO (in ContentValues value, long userID);
	 
	 void updateBuriedPoint(String phoneNumber, long module_id, long submodule_id, long function_id, long system_id,int type, long value,long userId,String other);
	 void updateSessionDAO(in RCSSession session);
	 void readMessage(String sessionId, String messageId);
	 
	 void getOfflineMsgWithParam(boolean isLogon, long peerId, long start, int pageSize, int unreadSet);
	 
	 void getSinglePublicOfflineMsgWithParam(long peerId, boolean readSet);
	 
	 void deleteFavoriteMsg(String messageId);
	 
	 void deleteJustChangeIsDelete(String sessionId, String messageId);
	 
	 ContentValues[] getAllSessionMessage(in String sessionId);
	 
	 ContentValues[] getSessionMessageByCount(in String sessionId,in int count);
	 
	 boolean setNotificationCenter (String clsName, int type);
	 boolean putNotificationCenterParams (String token, in Bundle b);
	 
	  void setChannelID(String channelID);
	  
	  void setOppenID(String oppenID);
	  
	  int getMessageCountTwo(String sessionId,in boolean isGetDeleted);
	  
	  void setNetworkState(byte state);
	  
	  void setLogOpen(boolean isOpen);
	  
	  
	  void deleteMessage(String sessionId, String messageId);
	  void deleteDraftMessageDAO(String sessionId);
	  void initSmileyResources (in int[] smiley_res_ids, int smiley_array);
	  boolean getUnreadMessageCountMessageDAOWithAt(String sessionId);
	  void clearAtMeMessage(String sessionId);
	  
	  void syncFavoriteMsg ();
	  void downloadFavoriteMsg (long curKey, int pageSize);
	  void refreshServerFavorList ();
	  
	  void updateStatusFavoriteMsgDAO (String messageId, int status);
	  
	  long getMessageSequence(String sessionId, String messageId);
	  void MessageDAOdelete(String sessionId);
	  
	  void navSetted ();
	  void checkNav ();
	  void inform ();
	  void setSoundOpen(boolean isOpen);
	  void setVibrateOpen(boolean isOpen);
	  void setTip(boolean isOpen);

	  void stopServices ();
	  long[] getInvitingIDsSocialInviteDAO ();
	  
	   List<view_pair> getAllEnterpriseEmpChat(boolean isIncludeDept, out List<AlphaSection> secs);
	   List<view_pair> getAllEnterpriseEmpWithoutLine(boolean isIncludeDept);

	   List<view_pair> getEntEmployeesBySearchKey(boolean isIncludeDept, String key,out List<AlphaSection> secs,boolean bFullBoard);
	   
	   List<view_pair> loadChildrenNodes(long parent_id,boolean isIncludeDept);
	   
	   List<view_pair> loadRootNodeList();
	   
	   DeptInfor getParentDetp (long id);
	   long[] getAllUserIdGroupMappingDAO();
	   long[] getAllUserIdOrganizeMappingDAO();
	   
	   EnterpriseInfo getEnterpriseByUserId(long userId);
	   
	   void RefreshSocialList (long userID, long topicID, int pageSize, TaskResult result);
	   void RefreshSocialListDir (long userID, long topicID, int pageSize, TaskResult result);
	   void LoadSocialList (long userID, long topicID, TaskResult result);
	   void LoadSocial (long topicID, TaskResult result);
	   void TakeCard (long userID, long version, TaskResult result);
	   void TakeFile (String path, long fileSize, String fileId, TaskResult result);
	   void TakeFiles (in String[] path, in long[] fileSize, in String[] fileId, String token, TaskResult result);
	
	   void fastDeleteTopicsSocialNotificationsDAO (in long[] toDelete);
	   TContact getEmployerById(long userId);

	   String getPingYin(String content);
	   void onSysContactChange();
}
